unit PSTools;
interface

type TProcSet=(psPageSize,psANSI,psPPLogo,psTextTools,psPPRenderer);
     TProcSets=set of TProcSet;

var PageSizeX:integer=595;
    PageSizeY:integer=842;
    MarginX:integer=28;
    MarginY:integer=42;

var PS:System.Text;

function CreatePS(const FileName:string;ProcSets:TProcSets):boolean;
procedure NextPage; overload;
procedure NextPage(const PageName:string); overload;
procedure ClosePS;

function PSEscape(const Literal:string):string;

implementation
uses Preview;

var CurrentPage:integer;              

function CreatePS(const FileName:string;ProcSets:TProcSets):boolean;
begin
  try
    AssignFile(PS,FileName); Rewrite(PS);
    writeln(PS,'%!PS-Adobe-1.0');
    writeln(PS,'%%Title: ',PreviewForm.Caption);
    writeln(PS,'%%Creator: PSTools for PaperPic III');
    writeln(PS,'%%BoundingBox: 0 0 ',PageSizeX,#32,PageSizeY);
    writeln(PS,'%%Pages: (atend)');
    writeln(PS,'%%EndComments');
    if (psPageSize IN ProcSets) then begin
      writeln(PS,'%%BeginFeature: PageSize');
      writeln(PS,'2 dict dup /PageSize [',PageSizeX,#32,PageSizeY,'] put dup /ImagingBBox null put setpagedevice');
      writeln(PS,'%%EndFeature');
    end;
    if (psANSI IN ProcSets) then begin
      writeln(PS,'%%BeginResource: procset ANSIEncoding 1.0 0');
      writeln(PS,'/reencodedict 5 dict def /ReEncode{reencodedict begin /newencoding exch def');
      writeln(PS,'/newfontname exch def /basefontname exch def /basefontdict basefontname');
      writeln(PS,'findfont def /newfont basefontdict maxlength dict def basefontdict { exch dup');
      writeln(PS,'/FID ne dup /Encoding ne and { exch newfont 3 1 roll put } { pop pop } ifelse');
      writeln(PS,'} forall newfont /FontName newfontname put newfont /Encoding newencoding put');
      writeln(PS,'newfontname newfont definefont pop end } def /bullets{{/bullet}repeat}bind def');
      writeln(PS,'/ANSIEncoding[/grave/acute/circumflex/tilde/macron/breve/dotaccent/dieresis');
      writeln(PS,'/ring/cedilla/hungarumlaut/ogonek/caron/dotlessi 18 bullets StandardEncoding');
      writeln(PS,'32 95 getinterval aload pop 3 bullets/quotesinglbase /florin/quotedblbase');
      writeln(PS,'/ellipsis/dagger/daggerdbl/circumflex/perthousand/Scaron/guilsinglleft/OE ');
      writeln(PS,'4 bullets/quoteleft/quoteright/quotedblleft/quotedblright/bullet/endash');
      writeln(PS,'/emdash/tilde/trademark/scaron/guilsinglright/oe 2 bullets /Ydieresis/space');
      writeln(PS,'/exclamdown/cent/sterling/currency/yen/brokenbar/section/dieresis/copyright');
      writeln(PS,'/ordfeminine/guillemotleft/logicalnot/hyphen/registered/macron/degree');
      writeln(PS,'/plusminus/twosuperior/threesuperior/acute/mu/paragraph/periodcentered/cedilla');
      writeln(PS,'/onesuperior/ordmasculine/guillemotright/onequarter/onehalf/threequarters');
      writeln(PS,'/questiondown/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/AE/Ccedilla');
      writeln(PS,'/Egrave/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex/Idieresis/Eth');
      writeln(PS,'/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis/multiply/Oslash/Ugrave');
      writeln(PS,'/Uacute/Ucircumflex/Udieresis/Yacute/Thorn/germandbls/agrave/aacute');
      writeln(PS,'/acircumflex/atilde/adieresis/aring/ae/ccedilla/egrave/eacute/ecircumflex');
      writeln(PS,'/edieresis/igrave/iacute/icircumflex/idieresis/eth/ntilde/ograve/oacute');
      writeln(PS,'/ocircumflex/otilde/odieresis/divide/oslash/ugrave/uacute/ucircumflex /udieresis');
      writeln(PS,'/yacute/thorn/ydieresis] def /ANSIEncode { ANSIEncoding ReEncode } bind def');
      writeln(PS,'%%EndResource');
    end;
    if (psPPLogo IN ProcSets) then begin
      writeln(PS,'%%BeginResource: procset PaperPicLogo 1.0 0');
      writeln(PS,'/third 1 3 div def /p13 { third add } bind def /DrawPaperPicLogo { gsave third');
      writeln(PS,'dup scale newpath 0 third 3 0 360 arc fill newpath 0 1 moveto 0 2 p13 dup -2');
      writeln(PS,'exch -2 1 curveto 2 1 lineto 2 -1 lineto -2 -1 lineto -2 0 p13 dup 0 exch 0 -1');
      writeln(PS,'curveto third setlinewidth 1 setgray stroke grestore } bind def');
      writeln(PS,'%%EndResource');
    end;
    if (psTextTools IN ProcSets) then begin
      writeln(PS,'%%BeginResource: procset TextTools 1.0 0');
      writeln(PS,'/center{dup stringwidth exch 2 div neg exch 2 div neg rmoveto show}bind def');
      writeln(PS,'/right{dup stringwidth exch neg exch neg rmoveto gsave show grestore}bind def');
      writeln(PS,'/mk2tt(0x)def/mk2text{dup 9 gt{(0000)cvs}{dup mk2tt exch 1 exch 10 mod 48 add');
      writeln(PS,'put mk2tt exch 0 exch 10 div cvi 48 add put mk2tt}ifelse}bind def');
      writeln(PS,'%%EndResource');
    end;
    if (psPPRenderer IN ProcSets) then begin
      writeln(PS,'%%BeginResource: procset PaperPicRenderer 3.0 0');
      writeln(PS,'/${load}bind def/pplss{/SizeX $/xofs load sub dup 0 gt{dup 5 gt{pop 5}if exch');
      writeln(PS,'/yofs $ add/PPData $ exch get/xofs $ exch 3 1 roll exch getinterval show}{pop');
      writeln(PS,'pop}ifelse}bind def/PPDraw{gsave translate /PPScale $ dup scale 13 -10');
      writeln(PS,'translate/PPGray $ setgray dup/ysize exch def 40 mul neg/ymax exch');
      writeln(PS,'def dup/xsize exch def 26 mul/xmax exch def/ystart exch def/xstart exch def');
      writeln(PS,'/xmax $ 10 moveto -13 10 lineto -13/ymax $ lineto/xmax $/ymax $ lineto');
      writeln(PS,'closepath/PPBoxLineWidth $ setlinewidth stroke/PPInnerLineWidth $ setlinewidth');
      writeln(PS,'/Helvetica-ANSI findfont 8 scalefont setfont -6.5 2 moveto (PP) center 0 1');
      writeln(PS,'/xsize $ 1 sub{dup 26 mul dup dup 10 moveto/ymax $ lineto stroke 2 add 2');
      writeln(PS,'moveto/xstart $ add mk2text show}for 0 1/ysize $ 1 sub{dup -40 mul dup dup -13');
      writeln(PS,'exch moveto/xmax $ exch lineto stroke 8 sub -6.5 exch moveto/ystart $ add');
      writeln(PS,'mk2text center}for/Courier-ANSI findfont 8 scalefont setfont 1 -38.5 translate');
      writeln(PS,'gsave 0 1/ysize $ 1 sub{/ystart $ add 5 mul/yofs exch def gsave 0 1/xsize $ 1');
      writeln(PS,'sub{/xstart $ add 5 mul/xofs exch def/yofs $/SizeY $ lt{0 32 moveto 0 pplss}if');
      writeln(PS,'/yofs $ 1 add/SizeY $ lt{0 24 moveto 1 pplss}if/yofs $ 2 add/SizeY $ lt{0 16');
      writeln(PS,'moveto 2 pplss}if/yofs $ 3 add/SizeY $ lt{0  8 moveto 3 pplss}if/yofs $ 4 add');
      writeln(PS,'/SizeY $ lt{0  0 moveto 4 pplss}if 26 0 translate}for grestore 0 -40 translate');
      writeln(PS,'}for grestore grestore}bind def/sat{2 copy load gt{exch def}{pop pop}ifelse}');
      writeln(PS,'bind def/PPDrawLegend{gsave translate/PPGray $ setgray/Helvetica findfont');
      writeln(PS,'/PPLegendFontSize $ scalefont setfont/spac/PPLegendFontSize $ .2 mul def');
      writeln(PS,'/pplwidth 0 def/ppxwidth 0 def/pcwidth 0 def PPLegend{dup 3 get stringwidth');
      writeln(PS,'pop/pcwidth sat dup 2 get stringwidth pop/ppxwidth sat 1 get stringwidth pop');
      writeln(PS,'/pplwidth sat}forall/pplwidth dup $(   Pixel = )stringwidth pop add/pcwidth $');
      writeln(PS,'add/ppxwidth $ add def/PPLegendFontSize $/spac $ add dup dup/hgt exch def 2');
      writeln(PS,'mul/pplwidth $ add/max exch def 1.2 mul dup/thgt exch def neg 0 exch');
      writeln(PS,'translate/hgt $ dup PPLegend length mul neg/ysz exch def/spac $ sub neg/base');
      writeln(PS,'exch def/ysz $/max $/thgt $ 0 1 index moveto 1 index exch lineto 1 index');
      writeln(PS,'lineto 0 exch lineto closepath/PPBoxLineWidth $ setlinewidth stroke');
      writeln(PS,'/Helvetica-BoldOblique-ANSI findfont/PPLegendFontSize $ 1.2 mul scalefont');
      writeln(PS,'setfont/spac $ 1.2 mul dup moveto (Legende:) show /PPInnerLineWidth $');
      writeln(PS,'setlinewidth/PPLegendFontSize $ 2 mul dup 0 moveto/ysz $ lineto stroke');
      writeln(PS,'/Courier-ANSI findfont/PPLegendFontSize $ scalefont setfont gsave PPLegend{ 0');
      writeln(PS,'0 moveto/max $ 0 lineto stroke/PPLegendFontSize $/base $ moveto 0 get center');
      writeln(PS,'0/hgt $ neg translate}forall grestore/Helvetica-ANSI findfont/PPLegendFontSize');
      writeln(PS,'$ scalefont setfont/fs1/PPLegendFontSize $ 2 mul/spac $ add def/fs2/max $/spac');
      writeln(PS,'$ sub def/fs3/fs2 $/pcwidth $ sub ( Pixel = ) stringwidth pop sub def gsave');
      writeln(PS,'PPLegend{/fs1 $/base $ moveto dup 1 get show/fs2 $/base $ moveto dup 3 get');
      writeln(PS,'right/fs3 $/base $ 2 copy moveto ( Pixel =) show moveto 2 get right 0/hgt $');
      writeln(PS,'neg translate}forall grestore grestore}bind def');
      writeln(PS,'%%EndResource');
    end;
  except
    Result:=false; exit;
  end;
  Result:=true;
  CurrentPage:=0;
end;

procedure NextPage; begin NextPage(''); end;

procedure NextPage(const PageName:string); begin
  if CurrentPage<0 then exit;
  if CurrentPage=0 then writeln(PS,'%%EndProlog');
  inc(CurrentPage);
  if PageName='' then writeln(PS,'%%Page: ',CurrentPage,#32,CurrentPage)
                 else writeln(PS,'%%Page: ',PageName,#32,CurrentPage);
end;

procedure ClosePS;
begin
  if CurrentPage<0 then exit;
  if CurrentPage>=0 then begin
    writeln(PS,'%%Trailer');
    writeln(PS,'%%Pages: ',CurrentPage);
  end;
  writeln(PS,'%%EOF');
  CloseFile(PS);
end;

function PSEscape(const Literal:string):string;
var p,m:integer;
  procedure ins; begin Insert('\',Result,p); inc(p); inc(m); end;
  procedure insc(c:char); begin ins; Result[p]:=c; end;
begin
  Result:=literal; m:=length(Result); p:=1;
  while p<=m do begin
    case Result[p] of
      '\','(',')':ins;
      #8:insc('b');
      #9:insc('t');
      #10:insc('n');
      #12:insc('f');
      #13:insc('r');
    end;
    inc(p);
  end;
end;

begin
  CurrentPage:=-1;
end.
