program PaperPic;

uses
  SysUtils,
  Forms,
  Dialogs,
  Preview in 'Preview.pas' {PreviewForm},
  PPControl in 'PPControl.pas',
  ImageProps in 'ImageProps.pas' {ImagePropsForm},
  PPCore in 'PPCore.pas',
  Colors in 'Colors.pas' {ColorsForm},
  ColorEdit in 'ColorEdit.pas' {ColorEditForm},
  PickColor in 'PickColor.pas' {PickColorForm},
  Intro in 'Intro.pas' {IntroForm},
  OPTNClassic in 'OPTNClassic.pas' {OPTNClassicForm},
  PSTools in 'PSTools.pas',
  MMExport in 'MMExport.pas',
  PageSetup in 'PageSetup.pas' {PageSetupForm},
  OPTNmm in 'OPTNmm.pas' {OPTNmmForm},
  PSExport in 'PSExport.pas',
  OPTNps in 'OPTNps.pas' {OPTNpsForm},
  FancyExport in 'FancyExport.pas';

{$R *.res}

var i:integer; s:string; ShowIntro:boolean;
begin
  Application.Initialize;
  Application.Title := 'PaperPic III';
  ShowIntro:=true;
  for i:=1 to ParamCount do begin
    s:=UpperCase(ParamStr(i));
    if (s='--HELP') OR (s='-H') OR (s='-?') OR (s='/?') then begin
      MessageDlg(
'Aufrufsyntax: '+ExtractFileName(ParamStr(0))+' [<Optionen>]'^M^M+
'<Optionen> knnen sein:'^M+
'--nointro = berspringt die Startanimation'^M+
'--fancyexport = schaltet coole Exportoptionen frei'
      ,mtInformation,[mbOK],0);
      halt;
    end;
    if s='--NOINTRO' then ShowIntro:=false;
    if copy(s,1,13)='--FANCYEXPORT' then Preview.EnableFancyExport:=true;
  end;
  if ShowIntro then
    Application.CreateForm(TIntroForm, IntroForm);
  Application.CreateForm(TPreviewForm, PreviewForm);
  Application.CreateForm(TImagePropsForm, ImagePropsForm);
  Application.CreateForm(TColorsForm, ColorsForm);
  Application.CreateForm(TColorEditForm, ColorEditForm);
  Application.CreateForm(TPickColorForm, PickColorForm);
  Application.CreateForm(TOPTNClassicForm, OPTNClassicForm);
  Application.CreateForm(TPageSetupForm, PageSetupForm);
  Application.CreateForm(TOPTNmmForm, OPTNmmForm);
  Application.CreateForm(TOPTNpsForm, OPTNpsForm);
  Application.Run;
end.
